stages:
  - test
  - build

# Select what we should cache
cache:
  paths:
  - vendor/

before_script:
# Install git, the php image doesn't have installed
- apt-get update -yqq
- apt-get install git -yqq

# Install mysql driver
- docker-php-ext-install pdo_mysql

# Install composer
- curl -sS https://getcomposer.org/installer | php

# Install all project dependencies
- php composer.phar install

variables:
  # Configure mysql service (https://hub.docker.com/_/mysql/)
  MYSQL_DATABASE: hello_world_test
  MYSQL_ROOT_PASSWORD: mysql

# We test PHP5.6 (the default) with MySQL
test:mysql:
  image: php:5.6
  services:
  - mysql:5.7.22
  stage: test
  script:
  - vendor/bin/phpunit --configuration phpunit_mysql.xml --coverage-text

# We test PHP7 with MySQL, but we allow it to fail
test:php7:mysql:
  stage: test
  image: php:7
  services:
  - mysql:5.7.22
  script:
  - vendor/bin/phpunit --configuration phpunit_mysql.xml --coverage-text
  allow_failure: true

build:package:
  stage: build
  only:
    - master
  image: rgevaert/docker-fpm:latest
  before_script:
  - apt-get update -yqq
  - apt-get install -y git
  script:
    - scripts/make-package.sh
  artifacts:
    paths:
    - "*deb"
